{
    "$graph": [
        {
            "class": "CommandLineTool",
            "label": "GATK4: CollectInsertSizeMetrics",
            "doc": "Provides useful metrics for validating library construction including the insert size distribution and read orientation of paired-end libraries",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "broadinstitute/gatk:4.1.3.0"
                }
            ],
            "inputs": [
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/javaOptions",
                    "label": "javaOptions",
                    "type": [
                        {
                            "type": "array",
                            "items": "string"
                        },
                        "null"
                    ]
                },
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/compression_level",
                    "label": "compression_level",
                    "doc": "Compression level for all compressed files created (e.g. BAM and VCF). Default value: 2.",
                    "type": [
                        "int",
                        "null"
                    ]
                },
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/bam",
                    "label": "bam",
                    "doc": "Input SAM or BAM file.  Required.",
                    "type": "File",
                    "secondaryFiles": [
                        ".bai"
                    ],
                    "inputBinding": {
                        "prefix": "-I",
                        "position": 10
                    }
                },
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/outputFilename",
                    "label": "outputFilename",
                    "doc": "File to write the output to.  Required.",
                    "type": [
                        "string",
                        "null"
                    ],
                    "default": "generated.metrics.txt",
                    "inputBinding": {
                        "prefix": "-O"
                    }
                },
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/outputHistogram",
                    "label": "outputHistogram",
                    "doc": "File to write insert size Histogram chart to.  Required. ",
                    "type": [
                        "string",
                        "null"
                    ],
                    "default": "generated.histogram.pdf",
                    "inputBinding": {
                        "prefix": "-H"
                    }
                },
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/argumentsFile",
                    "label": "argumentsFile",
                    "doc": "read one or more arguments files and add them to the command line",
                    "type": [
                        {
                            "type": "array",
                            "inputBinding": {
                                "prefix": "--arguments_file"
                            },
                            "items": "File"
                        },
                        "null"
                    ],
                    "inputBinding": {
                        "position": 10
                    }
                },
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/assumeSorted",
                    "label": "assumeSorted",
                    "doc": "If true (default), then the sort order in the header file will be ignored.  Default value: true. Possible values: {true, false}",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "--ASSUME_SORTED",
                        "position": 11
                    }
                },
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/deviations",
                    "label": "deviations",
                    "doc": "Generate mean, sd and plots by trimming the data down to MEDIAN + DEVIATIONS*MEDIAN_ABSOLUTE_DEVIATION. This is done because insert size data typically includes enough anomalous values from chimeras and other artifacts to make the mean and sd grossly misleading regarding the real distribution.  Default value: 10.0. ",
                    "type": [
                        "double",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "--DEVIATIONS",
                        "position": 11
                    }
                },
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/histogramWidth",
                    "label": "histogramWidth",
                    "doc": "Explicitly sets the Histogram width, overriding automatic truncation of Histogram tail. Also, when calculating mean and standard deviation, only bins <= Histogram_WIDTH will be included.  Default value: null. ",
                    "type": [
                        "int",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "--HISTOGRAM_WIDTH",
                        "position": 11
                    }
                },
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/includeDuplicates",
                    "label": "includeDuplicates",
                    "doc": "If true, also include reads marked as duplicates in the insert size histogram.  Default value: false. Possible values: {true, false} ",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "--INCLUDE_DUPLICATES",
                        "position": 11
                    }
                },
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/metricAccumulationLevel",
                    "label": "metricAccumulationLevel",
                    "doc": "The level(s) at  which to accumulate metrics.    This argument may be specified 0 or more times. Default value: [ALL_READS]. Possible values: {ALL_READS, SAMPLE, LIBRARY, READ_GROUP} .",
                    "type": [
                        "string",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "--METRIC_ACCUMULATION_LEVEL",
                        "position": 11
                    }
                },
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/minimumPCT",
                    "label": "minimumPCT",
                    "doc": "When generating the Histogram, discard any data categories (out of FR, TANDEM, RF) that have fewer than this percentage of overall reads. (Range: 0 to 1).  Default value: 0.05.",
                    "type": [
                        "float",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "--MINIMUM_PCT",
                        "position": 11
                    }
                },
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/stopAfter",
                    "label": "stopAfter",
                    "doc": "Stop after  processing N reads, mainly for debugging.  Default value: 0. ",
                    "type": [
                        "int",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "--STOP_AFTER",
                        "position": 11
                    }
                },
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/version",
                    "label": "version",
                    "doc": "display the version number for this tool Default value: false. Possible values: {true, false}",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "--version",
                        "position": 11
                    }
                },
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/showHidden",
                    "label": "showHidden",
                    "doc": "display hidden  arguments  Default  value: false.  Possible values: {true, false} ",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "--showHidden",
                        "position": 11
                    }
                }
            ],
            "stdout": "_stdout",
            "stderr": "_stderr",
            "baseCommand": [
                "gatk",
                "CollectInsertSizeMetrics"
            ],
            "arguments": [
                {
                    "prefix": "--java-options",
                    "position": -1,
                    "valueFrom": "$(\"-Xmx{memory}G {compression} {otherargs}\".replace(/\\{memory\\}/g, (([inputs.runtime_memory, 8, 4].filter(function (inner) { return inner != null })[0] * 3) / 4)).replace(/\\{compression\\}/g, (inputs.compression_level != null) ? (\"-Dsamjdk.compress_level=\" + inputs.compression_level) : \"\").replace(/\\{otherargs\\}/g, [inputs.javaOptions, []].filter(function (inner) { return inner != null })[0].join(\" \")))"
                }
            ],
            "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl",
            "outputs": [
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/out",
                    "label": "out",
                    "type": "File",
                    "outputBinding": {
                        "glob": "generated.metrics.txt",
                        "loadContents": false
                    }
                },
                {
                    "id": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl/Gatk4CollectInsertSizeMetrics/outHistogram",
                    "label": "outHistogram",
                    "type": "File",
                    "outputBinding": {
                        "glob": "generated.histogram.pdf",
                        "loadContents": false
                    }
                }
            ]
        },
        {
            "class": "Workflow",
            "label": "Performance summary workflow (whole genome)",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#main/bam",
                    "type": "File",
                    "secondaryFiles": [
                        ".bai"
                    ]
                },
                {
                    "id": "#main/sample_name",
                    "type": "string"
                },
                {
                    "id": "#main/genome_file",
                    "type": "File"
                },
                {
                    "id": "#main/samtoolsview_doNotOutputAlignmentsWithBitsSet",
                    "doc": "Do not output alignments with any bits set in INT present in the FLAG field. INT can be specified in hex by beginning with `0x' (i.e. /^0x[0-9A-F]+/) or in octal by beginning with `0' (i.e. /^0[0-7]+/) [0].",
                    "type": "string",
                    "default": "0x400"
                },
                {
                    "id": "#main/performancesummary_genome",
                    "doc": "calculate statistics for whole genome data.--target_flagstat must not be speicified",
                    "type": "boolean",
                    "default": true
                }
            ],
            "outputs": [
                {
                    "id": "#main/performanceSummaryOut",
                    "type": "File",
                    "outputSource": "#main/performancesummary/out"
                }
            ],
            "steps": [
                {
                    "id": "#main/gatk4collectinsertsizemetrics",
                    "label": "GATK4: CollectInsertSizeMetrics",
                    "in": [
                        {
                            "id": "#main/gatk4collectinsertsizemetrics/bam",
                            "source": "#main/bam"
                        }
                    ],
                    "run": "#Gatk4CollectInsertSizeMetrics_4_1_3_0.cwl",
                    "out": [
                        {
                            "id": "#main/gatk4collectinsertsizemetrics/out"
                        },
                        {
                            "id": "#main/gatk4collectinsertsizemetrics/outHistogram"
                        }
                    ]
                },
                {
                    "id": "#main/bamflagstat",
                    "label": "SamTools: Flagstat",
                    "in": [
                        {
                            "id": "#main/bamflagstat/bam",
                            "source": "#main/bam"
                        }
                    ],
                    "run": "#SamToolsFlagstat_1_9_0.cwl",
                    "out": [
                        {
                            "id": "#main/bamflagstat/out"
                        }
                    ]
                },
                {
                    "id": "#main/samtoolsview",
                    "label": "SamTools: View",
                    "in": [
                        {
                            "id": "#main/samtoolsview/doNotOutputAlignmentsWithBitsSet",
                            "source": "#main/samtoolsview_doNotOutputAlignmentsWithBitsSet"
                        },
                        {
                            "id": "#main/samtoolsview/sam",
                            "source": "#main/bam"
                        }
                    ],
                    "run": "#SamToolsView_1_9_0.cwl",
                    "out": [
                        {
                            "id": "#main/samtoolsview/out"
                        }
                    ]
                },
                {
                    "id": "#main/rmdupbamflagstat",
                    "label": "SamTools: Flagstat",
                    "in": [
                        {
                            "id": "#main/rmdupbamflagstat/bam",
                            "source": "#main/samtoolsview/out"
                        }
                    ],
                    "run": "#SamToolsFlagstat_1_9_0.cwl",
                    "out": [
                        {
                            "id": "#main/rmdupbamflagstat/out"
                        }
                    ]
                },
                {
                    "id": "#main/bedtoolsgenomecoveragebed",
                    "label": "BEDTools: genomeCoverageBed",
                    "in": [
                        {
                            "id": "#main/bedtoolsgenomecoveragebed/inputBam",
                            "source": "#main/samtoolsview/out"
                        },
                        {
                            "id": "#main/bedtoolsgenomecoveragebed/genome",
                            "source": "#main/genome_file"
                        }
                    ],
                    "run": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl",
                    "out": [
                        {
                            "id": "#main/bedtoolsgenomecoveragebed/out"
                        }
                    ]
                },
                {
                    "id": "#main/performancesummary",
                    "label": "Performance Summary",
                    "in": [
                        {
                            "id": "#main/performancesummary/flagstat",
                            "source": "#main/bamflagstat/out"
                        },
                        {
                            "id": "#main/performancesummary/collectInsertSizeMetrics",
                            "source": "#main/gatk4collectinsertsizemetrics/out"
                        },
                        {
                            "id": "#main/performancesummary/coverage",
                            "source": "#main/bedtoolsgenomecoveragebed/out"
                        },
                        {
                            "id": "#main/performancesummary/outputPrefix",
                            "source": "#main/sample_name"
                        },
                        {
                            "id": "#main/performancesummary/rmdupFlagstat",
                            "source": "#main/rmdupbamflagstat/out"
                        },
                        {
                            "id": "#main/performancesummary/genome",
                            "source": "#main/performancesummary_genome"
                        }
                    ],
                    "run": "#performanceSummary_0_0_7.cwl",
                    "out": [
                        {
                            "id": "#main/performancesummary/out"
                        }
                    ]
                }
            ],
            "id": "#main"
        },
        {
            "class": "CommandLineTool",
            "label": "SamTools: Flagstat",
            "doc": "Does a full pass through the input file to calculate and print statistics to stdout.\n\nProvides counts for each of 13 categories based primarily on bit flags in the FLAG field. Each category in the output is broken down into QC pass and QC fail. In the default output format, these are presented as \"#PASS + #FAIL\" followed by a description of the category.\n\nThe first row of output gives the total number of reads that are QC pass and fail (according to flag bit 0x200). For example:\n\n122 + 28 in total (QC-passed reads + QC-failed reads)\n\nWhich would indicate that there are a total of 150 reads in the input file, 122 of which are marked as QC pass and 28 of which are marked as \"not passing quality controls\"\n\nFollowing this, additional categories are given for reads which are:\n\nsecondary     0x100 bit set\n\nsupplementary     0x800 bit set\n\nduplicates     0x400 bit set\n\nmapped     0x4 bit not set\n\npaired in sequencing     0x1 bit set\n\nread1     both 0x1 and 0x40 bits set\n\nread2     both 0x1 and 0x80 bits set\n\nproperly paired     both 0x1 and 0x2 bits set and 0x4 bit not set\n\nwith itself and mate mapped     0x1 bit set and neither 0x4 nor 0x8 bits set\n\nsingletons     both 0x1 and 0x8 bits set and bit 0x4 not set\n\nAnd finally, two rows are given that additionally filter on the reference name (RNAME), mate reference name (MRNM), and mapping quality (MAPQ) fields:\n\nwith mate mapped to a different chr     0x1 bit set and neither 0x4 nor 0x8 bits set and MRNM not equal to RNAME\n\nwith mate mapped to a different chr (mapQ>=5)     0x1 bit set and neither 0x4 nor 0x8 bits set and MRNM not equal to RNAME and MAPQ >= 5)",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/samtools:1.9--h8571acd_11"
                }
            ],
            "inputs": [
                {
                    "id": "#SamToolsFlagstat_1_9_0.cwl/SamToolsFlagstat/bam",
                    "label": "bam",
                    "type": "File",
                    "inputBinding": {
                        "position": 10
                    }
                },
                {
                    "id": "#SamToolsFlagstat_1_9_0.cwl/SamToolsFlagstat/threads",
                    "label": "threads",
                    "doc": "Number of BAM compression threads to use in addition to main thread [0].",
                    "type": [
                        "int",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-@",
                        "position": 5
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#SamToolsFlagstat_1_9_0.cwl/SamToolsFlagstat/out",
                    "label": "out",
                    "type": "File",
                    "outputBinding": {
                        "glob": "_stdout"
                    }
                }
            ],
            "stdout": "_stdout",
            "stderr": "_stderr",
            "baseCommand": [
                "samtools",
                "flagstat"
            ],
            "arguments": [],
            "id": "#SamToolsFlagstat_1_9_0.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "SamTools: View",
            "doc": "Ensure SAMTOOLS.SORT is inheriting from parent metadata\n        \n---------------------------------------------------------------------------------------------------\n    \nWith no options or regions specified, prints all alignments in the specified input alignment file \n(in SAM, BAM, or CRAM format) to standard output in SAM format (with no header).\n\nYou may specify one or more space-separated region specifications after the input filename to \nrestrict output to only those alignments which overlap the specified region(s). \nUse of region specifications requires a coordinate-sorted and indexed input file (in BAM or CRAM format).",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/samtools:1.9--h8571acd_11"
                }
            ],
            "inputs": [
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/cramOutput",
                    "label": "cramOutput",
                    "doc": "Output in the CRAM format (requires -T).",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-C",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/compressedBam",
                    "label": "compressedBam",
                    "doc": "Enable fast BAM compression (implies -b).",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-1",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/uncompressedBam",
                    "label": "uncompressedBam",
                    "doc": "Output uncompressed BAM. This option saves time spent on compression/decompression and is thus preferred when the output is piped to another samtools command.",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-u",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/onlyOutputHeader",
                    "label": "onlyOutputHeader",
                    "doc": "Output the header only.",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-H",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/countAlignments",
                    "label": "countAlignments",
                    "doc": "Instead of printing the alignments, only count them and print the total number. All filter options, such as -f, -F, and -q, are taken into account.",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-c",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/writeAlignments",
                    "label": "writeAlignments",
                    "doc": "Write alignments that are not selected by the various filter options to FILE. When this option is used, all alignments (or all alignments intersecting the regions specified) are written to either the output file or this file, but never both.",
                    "type": [
                        "File",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-U",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/inputTSV",
                    "label": "inputTSV",
                    "doc": "A tab-delimited FILE. Each line must contain the reference name in the first column and the length of the reference in the second column, with one line for each distinct reference. Any additional fields beyond the second column are ignored. This file also defines the order of the reference sequences in sorting. If you run: `samtools faidx <ref.fa>', the resulting index file <ref.fa>.fai can be used as this FILE.",
                    "type": [
                        "File",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-t",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/onlyOverlapping",
                    "label": "onlyOverlapping",
                    "doc": "Only output alignments overlapping the input BED FILE [null].",
                    "type": [
                        "File",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-L",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/useMultiRegionIterator",
                    "label": "useMultiRegionIterator",
                    "doc": "Use the multi-region iterator on the union of the BED file and command-line region arguments. This avoids re-reading the same regions of files so can sometimes be much faster. Note this also removes duplicate sequences. Without this a sequence that overlaps multiple regions specified on the command line will be reported multiple times.",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-M",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/outputAlignmentsInReadGroup",
                    "label": "outputAlignmentsInReadGroup",
                    "doc": "Output alignments in read group STR [null]. Note that records with no RG tag will also be output when using this option. This behaviour may change in a future release.",
                    "type": [
                        "string",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-r",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/outputAlignmentsInFileReadGroups",
                    "label": "outputAlignmentsInFileReadGroups",
                    "doc": "Output alignments in read groups listed in FILE [null]. Note that records with no RG tag will also be output when using this option. This behaviour may change in a future release.",
                    "type": [
                        "File",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-R",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/mapqThreshold",
                    "label": "mapqThreshold",
                    "doc": "Skip alignments with MAPQ smaller than INT [0].",
                    "type": [
                        "int",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-q",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/outputAlignmentsInLibrary",
                    "label": "outputAlignmentsInLibrary",
                    "doc": "Only output alignments in library STR [null].",
                    "type": [
                        "string",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-l",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/outputAlignmentsMeetingCIGARThreshold",
                    "label": "outputAlignmentsMeetingCIGARThreshold",
                    "doc": "Only output alignments with number of CIGAR bases consuming query sequence \u2265 INT [0]",
                    "type": [
                        "int",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-m",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/outputAlignmentsWithBitsSet",
                    "label": "outputAlignmentsWithBitsSet",
                    "doc": "Only output alignments with all bits set in INT present in the FLAG field. INT can be specified in hex by beginning with `0x' (i.e. /^0x[0-9A-F]+/) or in octal by beginning with `0' (i.e. /^0[0-7]+/) [0].",
                    "type": [
                        "string",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-f",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/doNotOutputAlignmentsWithBitsSet",
                    "label": "doNotOutputAlignmentsWithBitsSet",
                    "doc": "Do not output alignments with any bits set in INT present in the FLAG field. INT can be specified in hex by beginning with `0x' (i.e. /^0x[0-9A-F]+/) or in octal by beginning with `0' (i.e. /^0[0-7]+/) [0].",
                    "type": [
                        "string",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-F",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/doNotOutputAlignmentsWithAllBitsSet",
                    "label": "doNotOutputAlignmentsWithAllBitsSet",
                    "doc": "Do not output alignments with all bits set in INT present in the FLAG field. This is the opposite of -f such that -f12 -G12 is the same as no filtering at all. INT can be specified in hex by beginning with `0x' (i.e. /^0x[0-9A-F]+/) or in octal by beginning with `0' (i.e. /^0[0-7]+/) [0].",
                    "type": [
                        "string",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-G",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/readTagToExclude",
                    "label": "readTagToExclude",
                    "doc": "Read tag to exclude from output (repeatable) [null]",
                    "type": [
                        "string",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-x",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/collapseBackwardCIGAR",
                    "label": "collapseBackwardCIGAR",
                    "doc": "Collapse the backward CIGAR operation.",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-B",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/subsamplingProportion",
                    "label": "subsamplingProportion",
                    "doc": "Output only a proportion of the input alignments. This subsampling acts in the same way on all of the alignment records in the same template or read pair, so it never keeps a read but not its mate. The integer and fractional parts of the -s INT.FRAC option are used separately: the part after the decimal point sets the fraction of templates/pairs to be kept, while the integer part is used as a seed that influences which subset of reads is kept.",
                    "type": [
                        "float",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-s",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/threads",
                    "label": "threads",
                    "doc": "Number of BAM compression threads to use in addition to main thread [0].",
                    "type": [
                        "int",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-@",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/sam",
                    "label": "sam",
                    "type": "File",
                    "inputBinding": {
                        "position": 10
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/reference",
                    "label": "reference",
                    "doc": "A FASTA format reference FILE, optionally compressed by bgzip and ideally indexed by samtools faidx. If an index is not present, one will be generated for you.",
                    "type": [
                        "File",
                        "null"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "-T",
                        "position": 6
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/outputFilename",
                    "label": "outputFilename",
                    "doc": "Output to FILE [stdout].",
                    "type": [
                        "string",
                        "null"
                    ],
                    "default": "generated.bam",
                    "inputBinding": {
                        "prefix": "-o",
                        "position": 5
                    }
                },
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/regions",
                    "label": "regions",
                    "doc": "Region specifications after the input filename to restrict output to only those alignments which overlap the specified region(s). Use of region specifications requires a coordinate-sorted and indexed input file (in BAM or CRAM format)",
                    "type": [
                        {
                            "type": "array",
                            "items": "string"
                        },
                        "null"
                    ],
                    "inputBinding": {
                        "position": 11
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#SamToolsView_1_9_0.cwl/SamToolsView/out",
                    "label": "out",
                    "type": "File",
                    "outputBinding": {
                        "glob": "generated.bam",
                        "loadContents": false
                    }
                }
            ],
            "stdout": "_stdout",
            "stderr": "_stderr",
            "baseCommand": [
                "samtools",
                "view"
            ],
            "arguments": [
                {
                    "position": 2,
                    "valueFrom": "-S"
                },
                {
                    "position": 3,
                    "valueFrom": "-h"
                },
                {
                    "position": 4,
                    "valueFrom": "-b"
                }
            ],
            "id": "#SamToolsView_1_9_0.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "BEDTools: genomeCoverageBed",
            "doc": "bedtools genomecov computes histograms (default), per-base reports (-d) and BEDGRAPH (-bg) summaries of feature coverage (e.g., aligned sequences) for a given genome. Note: 1. If using BED/GFF/VCF, the input (-i) file must be grouped by chromosome. A simple sort -k 1,1 in.bed > in.sorted.bed will suffice. Also, if using BED/GFF/VCF, one must provide a genome file via the -g argument. 2. If the input is in BAM (-ibam) format, the BAM file must be sorted by position. Using samtools sort aln.bam aln.sorted will suffice.",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/bedtools:2.29.2--hc088bd4_0"
                }
            ],
            "inputs": [
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/depth",
                    "label": "depth",
                    "doc": "Report the depth at each genome position (with one-based coordinates). Default behavior is to report a histogram.",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-d"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/depthZero",
                    "label": "depthZero",
                    "doc": "Report the depth at each genome position (with zero-based coordinates). Reports only non-zero positions. Default behavior is to report a histogram.",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-dz"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/BedGraphFormat",
                    "label": "BedGraphFormat",
                    "doc": "Report depth in BedGraph format. For details, see: genome.ucsc.edu/goldenPath/help/bedgraph.html",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-bg"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/BedGraphFormata",
                    "label": "BedGraphFormata",
                    "doc": "Report depth in BedGraph format, as above (-bg). However with this option, regions with zero coverage are also reported. This allows one to quickly extract all regions of a genome with 0  coverage by applying: 'grep -w 0$' to the output.",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-bga"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/split",
                    "label": "split",
                    "doc": "Treat 'split' BAM or BED12 entries as distinct BED intervals when computing coverage. For BAM files, this uses the CIGAR 'N' and 'D' operations to infer the blocks for computing coverage. For BED12 files, this uses the BlockCount, BlockStarts, and BlockEnds fields (i.e., columns 10,11,12).",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-split"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/strand",
                    "label": "strand",
                    "doc": "(STRING): can be + or -. Calculate coverage of intervals from a specific strand. With BED files, requires at least 6 columns (strand is column 6).",
                    "type": [
                        "string",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-strand"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/pairEnd",
                    "label": "pairEnd",
                    "doc": "Calculate coverage of pair-end fragments. Works for BAM files only",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-pc"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/fragmentSize",
                    "label": "fragmentSize",
                    "doc": "Force to use provided fragment size instead of read length. Works for BAM files only",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-fs"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/du",
                    "label": "du",
                    "doc": "Change strand af the mate read (so both reads from the same strand) useful for strand specific. Works for BAM files only",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-du"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/fivePos",
                    "label": "fivePos",
                    "doc": "Calculate coverage of 5' positions (instead of entire interval).",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-5"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/threePos",
                    "label": "threePos",
                    "doc": "Calculate coverage of 3' positions (instead of entire interval).",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-3"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/max",
                    "label": "max",
                    "doc": "Combine all positions with a depth >= max into a single bin in the histogram. Irrelevant for -d and -bedGraph",
                    "type": [
                        "int",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-max"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/scale",
                    "label": "scale",
                    "doc": "Scale the coverage by a constant factor. Each coverage value is multiplied by this factor before being reported. Useful for normalizing coverage by, e.g., reads per million (RPM). Default is 1.0; i.e., unscaled.",
                    "type": [
                        "float",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-scale"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/trackline",
                    "label": "trackline",
                    "doc": "Adds a UCSC/Genome-Browser track line definition in the first line of the output. - See here for more details about track line definition: http://genome.ucsc.edu/goldenPath/help/bedgraph.html - NOTE: When adding a trackline definition, the output BedGraph can be easily uploaded to the Genome Browser as a custom track, BUT CAN NOT be converted into a BigWig file (w/o removing the first line).",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-trackline"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/trackopts",
                    "label": "trackopts",
                    "doc": "Writes additional track line definition parameters in the first line. - Example: -trackopts 'name=\"My Track\" visibility=2 color=255,30,30' Note the use of single-quotes if you have spaces in your parameters.",
                    "type": [
                        "string",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-trackopts"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/inputBam",
                    "label": "inputBam",
                    "doc": "Input bam file. Note: BAM _must_ be sorted by position. A 'samtools sort <BAM>' should suffice.",
                    "type": [
                        "File",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-ibam"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/inputBed",
                    "label": "inputBed",
                    "doc": "Input bed file. Must be grouped by chromosome. A simple 'sort -k 1,1 <BED> > <BED>.sorted' will suffice.",
                    "type": [
                        "File",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-iBed"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/inputFile",
                    "label": "inputFile",
                    "doc": "Input file, can be gff/vcf.",
                    "type": [
                        "File",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-i"
                    }
                },
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/genome",
                    "label": "genome",
                    "doc": "Genome file. The genome file should tab delimited and structured as follows: <chromName><TAB><chromSize>.",
                    "type": [
                        "File",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "-g"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl/bedtoolsgenomeCoverageBed/out",
                    "label": "out",
                    "type": "File",
                    "outputBinding": {
                        "glob": "_stdout"
                    }
                }
            ],
            "stdout": "_stdout",
            "stderr": "_stderr",
            "baseCommand": [
                "genomeCoverageBed"
            ],
            "arguments": [],
            "id": "#bedtoolsgenomeCoverageBed_v2_29_2.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Performance Summary",
            "doc": "usage: performance_summary.py [-h] --flagstat FLAGSTAT\n                              --collect_insert_metrics COLLECT_INSERT_METRICS\n                              --coverage COVERAGE -o O\n                              [--target_flagstat TARGET_FLAGSTAT]\n                              [--rmdup_flagstat RMDUP_FLAGSTAT] [--genome]\n\nPerformance summary of bam\n\nrequired arguments:\n  --flagstat FLAGSTAT   output of samtools flagstat on bam\n  --collect_insert_metrics COLLECT_INSERT_METRICS\n                        output of CollectInsertMetrics (GATK or Picard) on bam\n  --coverage COVERAGE   output of bedtools coverageBed for targeted bam;\n                        bedtools genomeCoverageBed for whole genome bam\n  -o O                  output summary csv name\n\noptional arguments:\n  -h, --help            show this help message and exit\n  --target_flagstat TARGET_FLAGSTAT\n                        output of samtools flagstat of bam target on target\n                        bed. Only specified for targeted bam\n  --rmdup_flagstat RMDUP_FLAGSTAT\n                        output of samtools flagstat of removed duplicates bam.\n                        File to be used to extract mapping infomation if\n                        specified, instead of the --flagstat file.\n  --genome              calculate statistics for whole genome data.\n                        --target_flagstat must not be speicified\n        ",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "michaelfranklin/pmacutil:0.0.7"
                }
            ],
            "inputs": [
                {
                    "id": "#performanceSummary_0_0_7.cwl/performanceSummary/flagstat",
                    "label": "flagstat",
                    "doc": "output of samtools flagstat on bam",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--flagstat"
                    }
                },
                {
                    "id": "#performanceSummary_0_0_7.cwl/performanceSummary/collectInsertSizeMetrics",
                    "label": "collectInsertSizeMetrics",
                    "doc": "output of CollectInsertMetrics (GATK or Picard) on bam",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--collect_insert_metrics"
                    }
                },
                {
                    "id": "#performanceSummary_0_0_7.cwl/performanceSummary/coverage",
                    "label": "coverage",
                    "doc": "output of bedtools coverageBed for targeted bam; bedtools genomeCoverageBed for whole genome bam",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--coverage"
                    }
                },
                {
                    "id": "#performanceSummary_0_0_7.cwl/performanceSummary/outputPrefix",
                    "label": "outputPrefix",
                    "doc": "prefix of output summary csv",
                    "type": [
                        "string",
                        "null"
                    ],
                    "default": "generated.csv",
                    "inputBinding": {
                        "prefix": "-o"
                    }
                },
                {
                    "id": "#performanceSummary_0_0_7.cwl/performanceSummary/targetFlagstat",
                    "label": "targetFlagstat",
                    "doc": "output of samtools flagstat of bam target on target bed. Only specified for targeted bam",
                    "type": [
                        "File",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "--target_flagstat"
                    }
                },
                {
                    "id": "#performanceSummary_0_0_7.cwl/performanceSummary/rmdupFlagstat",
                    "label": "rmdupFlagstat",
                    "doc": "output of samtools flagstat of removed duplicates bam. File to be used to extract mapping infomation if specified, instead of the --flagstat file.",
                    "type": [
                        "File",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "--rmdup_flagstat"
                    }
                },
                {
                    "id": "#performanceSummary_0_0_7.cwl/performanceSummary/genome",
                    "label": "genome",
                    "doc": "calculate statistics for whole genome data.--target_flagstat must not be speicified",
                    "type": [
                        "boolean",
                        "null"
                    ],
                    "inputBinding": {
                        "prefix": "--genome"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#performanceSummary_0_0_7.cwl/performanceSummary/out",
                    "label": "out",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$((inputs.outputPrefix + \".csv\"))",
                        "outputEval": "$((inputs.outputPrefix.basename + \".csv\"))",
                        "loadContents": false
                    }
                }
            ],
            "stdout": "_stdout",
            "stderr": "_stderr",
            "baseCommand": "performance_summary.py",
            "arguments": [],
            "id": "#performanceSummary_0_0_7.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
